/* xkiss 1.032 (PC98kiss2.24c compatible) 1993/12/15 */

#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <stdio.h>
#include <ctype.h>

typedef enum {OFF,ON} STATE;

/* if you want, set default status ON or OFF */
STATE	big_mode     = OFF;	/* -b option */
STATE	palet_mode   = OFF;	/* -p option */
STATE	quiet_mode   = OFF;	/* -q option */
STATE	iconic_mode  = OFF;	/* -i option */
STATE	reverse_mode = OFF;	/* -r option */

/* if you want, set default color mode, ON state is only one */
STATE	color_mode       = ON;	/* -c option */
STATE	mono_dither_mode = OFF;	/* -m option */
STATE	mono_gosa_mode   = OFF;	/* -g option */

#define DEFAULT_SIKII_DITHER	39	/* if bigger, turn black */
#define DEFAULT_SIKII_GOSA	1500

#define	MAX_CELL	128
#define	MAX_SET		10
#define	MAX_PAL		10
#define	MAX_COLOR	16

#define MAX_SIZE_X      640
#define MAX_SIZE_Y	400
#define DEFAULT_SIZE_X  448
#define DEFAULT_SIZE_Y	320

#define	BTN_WIDTH	17
#define	BTN_HEIGHT	16
#define QUIT_WIDTH	40
#define	BTN_SPACE	2
#define	GROUP_SPACE	10
#define	FONT_X		5
#define	FONT_Y		14

#define BTN_Y_OFFSET (BTN_HEIGHT+BTN_SPACE*2+1)
#define BTN_X_SET    (BTN_SPACE)
#define BTN_X_PAL    (BTN_SPACE+GROUP_SPACE+(BTN_WIDTH+BTN_SPACE)*MAX_SET)
#define BTN_X_QUIT   (BTN_SPACE+GROUP_SPACE*2 + \
		      (BTN_WIDTH+BTN_SPACE)*(MAX_SET+MAX_PAL))

#define FONTNAME	"-*-helvetica-bold-r-normal--14-*-iso8859-1"

#define DEFAULT_BORDER_WIDTH	2

int	press_mark=-1,press_cell;
int	press_dx,press_dy;
int	fix_press_x,fix_press_y;
STATE	pesi_flag;

typedef struct {
    int			mark;
    int			init_fix,fix;
    char		name[256];
    enum {NOUSE,USE}	set[MAX_SET];
    int			xsize,ysize;
    unsigned char 	*buf,*mono_buf;
    int			x[MAX_SET],y[MAX_SET];
    GC			gc[MAX_PAL],paint_gc[MAX_PAL][MAX_COLOR],gc_bw[2];
    Pixmap		pix[MAX_PAL],clip_pix;
    int			pal;
} CELL;

CELL cell[MAX_CELL];

int	init_fix[MAX_CELL],fix[MAX_CELL];

int	cnf_size_x=DEFAULT_SIZE_X, cnf_size_y=DEFAULT_SIZE_Y;
int	size_x    =DEFAULT_SIZE_X, size_y    =DEFAULT_SIZE_Y;

int	pb[MAX_SET];
XColor	palet[MAX_PAL][MAX_COLOR];
int	outor_palet; /* set but no use */
int	palet_array[MAX_PAL];
int	sum_rgb[MAX_PAL][MAX_COLOR];

int	current_set=0;

char	*disp_name=NULL;
char	*geometry_string=NULL;
Display	*disp;
int	scr;
Window	w,rootwin;
Pixmap	world_pix,mono_background_pix;
GC	world_gc,mono_background_gc;
unsigned long	w_pixel,b_pixel;

int	sikii_dither = DEFAULT_SIKII_DITHER; 
int	sikii_gosa   = DEFAULT_SIKII_GOSA;

#define SYS_COL	3
GC	gc_button[SYS_COL];
typedef	enum	BUTTON_COLOR {BLACK=0,GREEN=1,ORANGE=2} COLOR;
char	*color_name[]= {"black","palegreen","tan2"};
char	*mono_color_name[] = {"black","white","black"};
char	*mono_reverse_color_name[] = {"white","black","white"};

enum GROUP { SET,PAL,QUIT };
STATE	quit_state=OFF;

GC	root_box_gc;
int	root_sx,root_sy,root_ex,root_ey;
STATE	root_flag;
STATE	root_paste_flag=OFF;

char	path[256],config_file[100];

/*
 * Utility
 */

void check_str(char *str)
{
    char *p;
    for (p=str;*p!='\0';p++) {
	if (*p=='\n' || *p=='\r' || *p=='\t')	*p=' ';
	if (*p==';') {
	    *p='\0';
	    break;
	}
    }
}

char *skip_str(char *str)
{
    char *p;
    for (p=str;*p==' ';p++);
    for (;*p!=' ';p++)
	if (*p=='\0') return(p);
    for (;*p==' ';p++);
    return(p);
}

void usage(char *fn)
{
    if (fn!=NULL) fprintf(stderr,"Can't find file (%s).\n",fn);
    fprintf(stderr,"xkiss 1.031 (pc98kiss 2.24c compatible)\n");
    fprintf(stderr,"Usage : xkiss [option][load_path][config_file]\n");
    fprintf(stderr,"[option]:\n");
    fprintf(stderr,"\t-p         :small-memory & fast-start mode\n");
    fprintf(stderr,"\t-b         :big mode\n");
    fprintf(stderr,"\t-i         :iconic mode\n");
    fprintf(stderr,"\t-d display :set display name\n");
    fprintf(stderr,"\t-g geom    :set geometry string\n");
    fprintf(stderr,"\t-c         :color mode\n");
    fprintf(stderr,"\t-m num     :monochrome mode(default %d)\n",sikii_dither);
    fprintf(stderr,"\t-e num     :monochrome mode(default %d)\n",sikii_gosa);
    fprintf(stderr,"\t-r         :reverse mode(only monochrome mode)\n");
    fprintf(stderr,"\t-q         :quiet mode\n");
    exit(-1);
}

FILE *msdos_fopen(char *fn,char *mode)
{
    FILE	*fp;
    char	*p;
    char	pathname[256],filename[256],*f;

    sprintf(filename,"%s",fn);
    check_str(filename);
    for (p=filename;*p!=' ' && *p!='\0';p++);
    *p='\0';
    
    sprintf(pathname,"%s%s",path,filename);
    if ((fp=fopen(pathname,mode))!=NULL)
	return(fp);
    
    for (p=filename;*p!='\0';p++)
	if (islower(*p)) *p=toupper(*p);
    sprintf(pathname,"%s%s",path,filename);
    if ((fp=fopen(pathname,mode))!=NULL)
	return(fp);
    
    for (p=filename;*p!='\0';p++)
	if (isupper(*p)) *p=tolower(*p);
    sprintf(pathname,"%s%s",path,filename);
    if ((fp=fopen(pathname,mode))!=NULL)
	return(fp);

    return(NULL);
}

FILE *kiss_fopen(char *fn,char *mode)
{
    FILE	*fp;

    if ((fp=msdos_fopen(fn,mode))==NULL) {
	usage(fn);
	exit(0);
    }
    return(fp);
}

/*
 * Data load
 */

void load_data_cell(char *fn,int num)
{
    FILE	*fp;
    unsigned char	byte_h,byte_l;
    unsigned char	b[(MAX_SIZE_X+1)/2],b2[MAX_SIZE_X];
    int		i,j;
    int		xs,ys;
    
    fp=kiss_fopen(fn,"r");
    fread(&byte_l,1,1,fp);
    fread(&byte_h,1,1,fp);
    xs = byte_h*256+byte_l;
    fread(&byte_l,1,1,fp);
    fread(&byte_h,1,1,fp);
    ys = byte_h*256+byte_l;
    
    if (big_mode==OFF)	cell[num].buf = (unsigned char *)malloc(xs*ys  );
    else		cell[num].buf = (unsigned char *)malloc(xs*ys*4);

    for (j=0;j<ys;j++) {
	fread(b,1,(xs+1)/2,fp);
	for (i=0;i<(xs+1)/2;i++) {
	    b2[i*2  ] = (b[i]>>4)&0x0f;
	    b2[i*2+1] = b[i]&0x0f;
	}
	for (i=0;i<xs;i++) {
	    if (big_mode==OFF) {
		cell[num].buf[xs*j + i]=b2[i];
	    } else {
		cell[num].buf[(xs*(j*2  )+i)*2  ]=b2[i];
		cell[num].buf[(xs*(j*2  )+i)*2+1]=b2[i];
		cell[num].buf[(xs*(j*2+1)+i)*2  ]=b2[i];
		cell[num].buf[(xs*(j*2+1)+i)*2+1]=b2[i];
	    }
	}
    }
    fclose(fp);
    if (big_mode==ON) {
	xs *=2;	
	ys *=2;
    } 
    cell[num].xsize = xs;
    cell[num].ysize = ys;
}

void load_palet(char *fn)
{
    FILE	*fp;
    unsigned char	byte_h,byte_l;
    int		p,c;
    int		r,g,b;
    
    check_str(fn);
    fp=kiss_fopen(fn,"r");
    for (p=0;p<MAX_PAL;p++)
	for (c=0;c<MAX_COLOR;c++) {
	    fread(&byte_l,1,1,fp);
	    fread(&byte_h,1,1,fp);
	    r = (byte_l>>4)&0x0f;
	    g = (byte_h   )&0x0f;
	    b = (byte_l   )&0x0f;
	    if (color_mode==ON) {
		palet[p][c].red   = r*0x1111;
		palet[p][c].green = g*0x1111;
		palet[p][c].blue  = b*0x1111;
	    }
	    if (mono_dither_mode==ON)
		sum_rgb[p][c] = (g*59 + r*30 + b*11)/33;
	    if (mono_gosa_mode==ON)
		sum_rgb[p][c] = g*59 + r*30 + b*11;
	}
    fclose(fp);
}

void load_config_set(int set,char *str)
{
    int		n;
    char	*p=str;
    
    check_str(str);
    sscanf(str,"%d",&pb[set]);
    for (n=0;n<MAX_CELL;n++) {
	p=skip_str(p);
	if (*p!='*') {
	    int	i,x,y;
	    if (sscanf(p,"%d,%d",&x,&y)!=2) break;
	    if (big_mode==ON) {
		x*=2;
		y*=2;
	    }
	    for (i=0;i<MAX_CELL;i++)
		if (cell[i].mark==n) {
		    cell[i].x[set]=x;
		    cell[i].y[set]=y;
		}	
	}
    }	
}

void load_config_size(char *str)
{
    char	*p;
    for (p=str;*p!='\0';p++)
	if (!isdigit(*p)) *p=' ';
    sscanf(str,"%d %d",&cnf_size_x ,&cnf_size_y);
    if (big_mode==ON) {
	cnf_size_x*=2;
	cnf_size_y*=2;
    }
    size_x=cnf_size_x;
    size_y=cnf_size_y;
}

void load_config_cell(int num,char *str)
{
    char	*p,*pp,c;
    int		i,j,n;
    
    check_str(str);
    sscanf(str,"%d",&cell[num].mark);

    for (p=str;;p++)
	if (!isdigit(*p)) break;
    if (*p=='.') {
	p++;
	for (pp=p;;p++)
	    if (*p==' ' || (!isdigit(*p)))	
		break;
	c=*p;
	*p='0';
	sscanf(pp,"%d",&j);
	cell[num].init_fix=j;
	cell[num].fix=j;
	*p=c;
    }
    for (;;p++)
	if (*p!=' ') break;

    sscanf(p,"%s",cell[num].name);
    str=skip_str(p);
    
    load_data_cell(cell[num].name,num);
    
    for (p=str;*p!='\0';p++)
	if (*p==':') {
	    p++;
	    for (i=0;i<MAX_SET;i++)
		cell[num].set[i]=NOUSE;
	    for (;;) {
		if (sscanf(p,"%d",&j)==0) break;
		if (0<=j && j<MAX_SET)	cell[num].set[j]=USE;
		p=skip_str(p);
		if (*p=='\0') break;
	    }
	    return;
	}

    for (i=0;i<MAX_SET;i++)
	cell[num].set[i]=USE;
}

void arg_check(int argc,char **argv)
{
    char	*arg_str[20];
    int		arg=0,i;
    int		sikii;

    for (i=1;i<argc;i++) {
	if (argv[i][0]=='-') {
	    switch (argv[i][1]) {
	    case 'b': 
		big_mode     =(big_mode    ==ON) ? OFF : ON;	break;
	    case 'p': 
		palet_mode   =(palet_mode  ==ON) ? OFF : ON;	break;
	    case 'q':
		quiet_mode   =(quiet_mode  ==ON) ? OFF : ON;	break;
	    case 'i':
		iconic_mode  =(iconic_mode ==ON) ? OFF : ON;	break;
	    case 'r':
		reverse_mode =(reverse_mode==ON) ? OFF : ON;	break;
	    case 'd': 
		disp_name=argv[++i];		break;
	    case 'g':
		geometry_string=argv[++i];	break;
	    case 'c':
		color_mode       = ON;
		mono_dither_mode = OFF;
		mono_gosa_mode   = OFF;
		break;
	    case 'm':
		color_mode       = OFF;
		mono_dither_mode = ON;
		mono_gosa_mode   = OFF;
		if (sscanf(&argv[i][2],"%d",&sikii)==1) {
		    sikii_dither=sikii;
		} else {
		    if (i+1 < argc && sscanf(argv[i+1],"%d",&sikii)==1) {
			sikii_dither=sikii;
			i++;
		    }
		}
		break;
	    case 'e':
		color_mode       = OFF;
		mono_dither_mode = OFF;
		mono_gosa_mode   = ON;
		if (sscanf(&argv[i][2],"%d",&sikii)==1) {
		    sikii_gosa=sikii;
		} else {
		    if (i+1 < argc && sscanf(argv[i+1],"%d",&sikii)==1) {
			sikii_gosa=sikii;
			i++;
		    }
		}
		break;
	    default:
		usage(NULL);
	    }
	} else {
	    arg_str[arg++]=argv[i];
	}
    }

    if (arg==0) {
	sprintf(path,"./");
	sprintf(config_file,"kiss.cnf");
    }
    if (arg==1) {
	FILE	*fp;
	char	*p,*pp=NULL;
	sprintf(path,"%s/",arg_str[0]);
	sprintf(config_file,"kiss.cnf");
	if ((fp=msdos_fopen(config_file,"r"))!=NULL) {
	    fclose(fp);
	} else {
	    for (p=arg_str[0];*p!='\0';p++)	
		if (*p=='/') pp=p;
	    if (pp==NULL) {
		sprintf(path,"./");
		sprintf(config_file,"%s",arg_str[0]);
	    } else {
		*pp='\0';
		sprintf(path,"%s/",arg_str[0]);
		sprintf(config_file,"%s",pp+1);
	    }	    
	}
    }
    if (arg==2) {
	sprintf(path,"%s/",arg_str[0]);
	sprintf(config_file,"%s",arg_str[1]);
    }
    if (arg>=3) {
	fprintf(stderr,"argument error!\n");
	usage(NULL);
    }
}

void load_config()
{
    FILE	*fp;
    int		num=0,set=-1,i;
    char	str[1024];
    static char	set_str[MAX_SET][8*MAX_CELL+10];
    STATE	palet_load_flag;

    fp=kiss_fopen(config_file,"r");
    if (quiet_mode==OFF)
	fprintf(stderr,"loading config file (%s%s)...\n",path,config_file);

    for (i=0;i<MAX_CELL;i++) {
	cell[i].mark=-1;
	cell[i].init_fix=0;
	cell[i].fix=0;
	init_fix[i]=0;
	fix[i]=0;
    }

    palet_load_flag=OFF;
    while (fgets(str,1024,fp)!=NULL) {
	switch (str[0]) {
	case '%':
	    load_palet(str+1);
	    palet_load_flag=ON;
	    break;
	case '[':
	    outor_palet=atoi(str+1);
	    break;
	case '(':
	    load_config_size(str+1);
	    break;
	case '#':
	    load_config_cell(num++,str+1);
	    break;
	case '$':
	    strcpy(set_str[++set],str+1);
	    break;
	case ' ':
	    strcat(set_str[set],str+1);
	    break;
	}
    }
    fclose(fp);

    if (palet_load_flag==OFF)	usage(config_file);

    if (big_mode==ON) {
	cnf_size_x*=2;
	cnf_size_y*=2;
    }
    for (i=0;i<=set;i++)
	load_config_set(i,set_str[i]);

    for (i=0;i<MAX_CELL;i++) {
	init_fix[i]=0;
	fix[i]=0;
    }
    for (i=0;i<MAX_CELL;i++) {
	int	f;
	if (cell[i].mark==-1) continue;
	f=cell[i].init_fix;
	if (init_fix[cell[i].mark]<f) {
	    init_fix[cell[i].mark]=+f;
	    fix[cell[i].mark]=+f;
	}
    }
}

void save()
{
    int		i,j,k,m,n=0;
    FILE	*fp_w,*fp_r;
    static char buf[2048];

    fp_w=fopen("xkiss.cnf","w");
    fp_r=kiss_fopen(config_file,"r");
   
    while (fgets(buf,2048,fp_r)!=NULL)
	if (buf[0]!='$' && buf[0]!=' ')
	    fprintf(fp_w,"%s",buf);
    fclose(fp_r);

    for (k=0;k<MAX_SET;k++) {
	fprintf(fp_w,"$%d ",pb[k]);
	for (i=0;i<MAX_CELL;i++) {
	    m=-1;
	    for (j=0;j<MAX_CELL;j++)
		if (cell[j].mark==i) m=j;
	    if (m==-1 || cell[m].set[k]==0) fprintf(fp_w,"* ");
	    else fprintf(fp_w,"%d,%d ",cell[m].x[k],cell[m].y[k]);
	    if (n++==16) {
		n=0;
		fprintf(fp_w,"\n ");
	    }
	}
	fprintf(fp_w,"\n");
    }
    fclose(fp_w);
}

/*
 * X Drawing Utility
 */

void quit()
{
    Visual	*vis;

/*  save(); */

    XDestroyWindow(disp,w);

    vis = DefaultVisual(disp,scr);
    if (root_paste_flag==ON) {
	if (vis->class !=StaticColor && vis->class!=StaticGray) {
	    Atom	atom;
	    Pixmap	pix;
	    atom = XInternAtom(disp, "_XSET_ROOT_ID", False);
	    pix = XCreatePixmap(disp, rootwin, 1,1,XDefaultDepth(disp,0));
	    XChangeProperty(disp, rootwin, atom, XA_PIXMAP, 32,
			    PropModeReplace,(unsigned char *)&pix, 1);
	    XSetCloseDownMode(disp, RetainTemporary);
	}
    }
    XCloseDisplay(disp);
    exit(0);
}

void monochrome_sub(unsigned char *cbuf,unsigned char *mbuf,
		    int dx,int dy,int p)
{
    static int  d_tbl[4][4] = {
	{  0, 12,  3, 15 },
	{ 18,  6, 21,  9 },
	{  3, 15, 18, 12 },
	{ 21, 12, 18,  6 }
    };
    int		tone_buf[2][3000];
    int		tone,carry,lb,lc;
    int		x,y;
    int		c,color;

    if (mono_dither_mode==ON) {
	for (y=0;y<dy;y++)
	    for (x=0;x<dx;x++) {
		c=(int)(*cbuf++);
		color=sum_rgb[p][c]+d_tbl[y%4][x%4];
		*mbuf++ = (color>sikii_dither) ? 0:1;
	    }
    } else {
	for (y=0;y<2;y++)
	    for (x=0;x<dx;x++)
		tone_buf[y][x]=0;

	for (y=0;y<dy;y++) {
	    lb=(y+1)&1;
	    lc=y&1;
	    carry=0;
	    for (x=0;x<dx;x++)
		tone_buf[lb][x]=0;
	    for (x=0;x<dx;x++) {
		c=*cbuf++;
		tone = sum_rgb[p][c] + tone_buf[lc][x] + carry;
		if (tone >= sikii_gosa) {
		    tone-=sikii_gosa;
		    *mbuf++=0;
		} else {
		    *mbuf++=1;
		}
		carry = tone >>3;
		tone_buf[lb][x] += carry + (tone & 7);
		tone_buf[lb][x>0 ? x-1 : x]+=carry<<1;
		tone_buf[lb][x<x-1 ? x+1:x]+=carry;
		carry<<=2;
	    }
	}
    }
}
void monochrome(int n,int p)
{
    monochrome_sub(cell[n].buf,cell[n].mono_buf,
		   cell[n].xsize,cell[n].ysize,p);
}

void make_mono_background(STATE flag)
{
    static int	mono_background_palet=-1;
    unsigned char *cbuf,*mbuf,*b;
    int	x,y;

    if(flag==OFF && sum_rgb[pb[current_set]][0]==mono_background_palet) return;
    mono_background_palet=sum_rgb[pb[current_set]][0];

    cbuf=(unsigned char *)malloc(size_x*size_y);
    mbuf=(unsigned char *)malloc(size_x*size_y);
    b=cbuf;
    for (y=0;y<size_y;y++)
	for (x=0;x<size_x;x++)
	    *b++=0;
    monochrome_sub(cbuf,mbuf,size_x,size_y,pb[current_set]);
    XSetForeground(disp,mono_background_gc,w_pixel);
    XFillRectangle(disp,mono_background_pix,mono_background_gc,
		   0,0,size_x,size_y);
    XSetForeground(disp,mono_background_gc,b_pixel);
    b=mbuf;
    for (y=0;y<size_y;y++)
	for (x=0;x<size_x;x++)
	    if ((*b++)==1)
		XDrawPoint(disp, mono_background_pix,mono_background_gc, x,y);
    free(mbuf);
    free(cbuf);
}

void make_palet()
{
    int         p,c,i,j;
    XColor	col;

    if (color_mode==ON) {	/* color */
	for (p=0; p<MAX_PAL; p++)
	    for (c=0; c<MAX_COLOR; c++)
		XAllocColor(disp, DefaultColormap(disp,0), &palet[p][c]);
    }
    for (i=0;i<MAX_PAL;i++) {
	palet_array[i]=i;
	for (j=0;j<i;j++) {
	    STATE flag=ON;
	    for (c=0;c<MAX_PAL;c++) {
		if (color_mode==ON && palet[i][c].pixel!=palet[j][c].pixel)
		    flag=OFF;
		if (color_mode==OFF && sum_rgb[i][c]!=sum_rgb[j][c])
		    flag=OFF;
	    }
	    if (flag==ON) {
		palet_array[i]=j;
		break;
	    }
	}
    }
}	

void make_clip_pixmap()
{
    Pixmap	bpix;
    GC		bgc;
    int		xs,ys;
    int		x,y,n;

    unsigned char	*b;
    int		xp_num;
    XPoint	*xpts,*xpt;
  
#define	MAX_POINTS	2048	/* for XDrawPoints */

    xpts=(XPoint *)malloc(sizeof(XPoint)*MAX_POINTS);

    for (n=0;n<MAX_CELL;n++) {
	if (cell[n].mark==-1) continue;
	xs=cell[n].xsize;
	ys=cell[n].ysize;
	bpix=XCreatePixmap(disp,w,xs,ys,1);
	bgc=XCreateGC(disp,bpix,0,NULL);
	XSetForeground(disp,bgc,0);
	XFillRectangle(disp,bpix,bgc, 0,0, xs,ys);
	XSetForeground(disp,bgc,1);
	b=cell[n].buf;

	xpt=xpts;
	xp_num=0;
	for (y=0;y<ys;y++)
	    for (x=0;x<xs;x++) {
		if ((*b++)==0) continue;
		xpt->x=x;
		xpt->y=y;
		xpt++;
		xp_num++;
		if (xp_num==MAX_POINTS) {
		    XDrawPoints(disp,bpix,bgc,xpts,xp_num,CoordModeOrigin);
		    xpt=xpts;
		    xp_num=0;
		}
	    }
	if (xp_num>0)
	    XDrawPoints(disp,bpix,bgc,xpts,xp_num,CoordModeOrigin);
/*
        for (y=0;y<ys;y++)
            for (x=0;x<xs;x++)
                if ((*b++)!=0) XDrawPoint(disp,bpix,bgc,x,y);
*/
	cell[n].clip_pix=bpix;
	XFreeGC(disp, bgc);
    }
    free(xpts);
}

void repaint_pixmap(int new_pal,STATE init_mode)
{
    int		x,y,n,p;
    STATE	pal_array[MAX_COLOR];
    int		xs,ys;
    
    pal_array[0]=OFF;
    for (n=0;n<MAX_CELL;n++) {
	int	c;
	if (cell[n].mark==-1) continue;
	if (cell[n].pal==new_pal) continue;
	for (c=1;c<MAX_COLOR;c++)
	    pal_array[c]=ON;
	if (init_mode==OFF || cell[n].pal!=-1)
	    for (c=1;c<MAX_COLOR;c++) {
		if (color_mode==ON) {	/* color */
		    if (palet[new_pal][c].pixel==palet[cell[n].pal][c].pixel)
			pal_array[c]=OFF;
		} else {		/* monochrome */
		    if (sum_rgb[new_pal][c]==sum_rgb[cell[n].pal][c])
			pal_array[c]=OFF;
		}
	    }
	xs=cell[n].xsize;
	ys=cell[n].ysize;

	if (color_mode==ON) {	/* color */
	    unsigned char *b;
	    int		c;
	    b=cell[n].buf;
	    for (y=0;y<ys;y++)
		for (x=0;x<xs;x++)
		    if (pal_array[c=*b++]==ON)
			XDrawPoint(disp, cell[n].pix[0],
				   cell[n].paint_gc[new_pal][c],x,y);
	} else {		/* monochrome */
	    unsigned char	*b,*mb;
	    int		c;
	    monochrome(n,new_pal);
	    b=cell[n].buf;
	    mb=cell[n].mono_buf;
	    for (y=0;y<ys;y++)
		for (x=0;x<xs;x++) {
		    if (pal_array[c=*b++]==ON)
			XDrawPoint(disp,cell[n].pix[0],cell[n].gc_bw[*mb],x,y);
		    mb++;
		}
	}
	cell[n].pal=new_pal;
	if (init_mode==ON && quiet_mode==OFF) {
	    fprintf(stderr,".");
	    fflush(stderr);
	}
    }
}

void init_cell_pixmap()
{
    Pixmap	cpix;
    XGCValues	gcv;
    int		n,p,c,x,y;
    int		xs,ys;
    unsigned char	*b;
    
    make_clip_pixmap();

    if (palet_mode==ON) {
	for (n=0;n<MAX_CELL;n++) {
	    if (cell[n].mark==-1) continue;
	    xs=cell[n].xsize;
	    ys=cell[n].ysize;
	    cpix=XCreatePixmap(disp,w,xs,ys,XDefaultDepth(disp,0));
	    cell[n].gc[0]=XCreateGC(disp,cpix,0,NULL);
	    if (color_mode==ON) {	/* color */
		for (p=0;p<MAX_PAL;p++)
		    for (c=0;c<MAX_COLOR;c++) {
			gcv.foreground=palet[p][c].pixel;
			cell[n].paint_gc[p][c]
			    =XCreateGC(disp,cpix,GCForeground,&gcv);
		    }	
	    } else {			/* monochrome */
		cell[n].gc_bw[0]=XCreateGC(disp,cpix,0,NULL);
		cell[n].gc_bw[1]=XCreateGC(disp,cpix,0,NULL);
		XSetForeground(disp,cell[n].gc_bw[0],w_pixel);
		XSetForeground(disp,cell[n].gc_bw[1],b_pixel);
		cell[n].mono_buf=(unsigned char *)malloc(xs*ys);
	    }
	    XSetClipMask(disp,cell[n].gc[0],cell[n].clip_pix);
	    cell[n].pal=-1;
	    cell[n].pix[0]=cpix;
	}
	repaint_pixmap(pb[current_set],ON);
    } else {
	for (n=0;n<MAX_CELL;n++) {
	    if (cell[n].mark==-1) continue;
	    xs=cell[n].xsize;
	    ys=cell[n].ysize;

	    for (p=0;p<MAX_PAL;p++) {
		if (palet_array[p]!=p)	continue; 
		cpix=XCreatePixmap(disp,w,xs,ys,XDefaultDepth(disp,0));
		cell[n].gc[p]=XCreateGC(disp,cpix,0,NULL);
		XSetClipMask(disp,cell[n].gc[p],cell[n].clip_pix);
		if (color_mode==ON) {	/* color */
		    for (c=0;c<MAX_COLOR;c++) {
			gcv.foreground=palet[p][c].pixel;
			cell[n].paint_gc[p][c]
			    =XCreateGC(disp,cpix,GCForeground,&gcv);
		    }
		    b=cell[n].buf;
		    for (y=0;y<ys;y++)
			for (x=0;x<xs;x++) {
			    if ((c=*b++)!=0)
				XDrawPoint(disp, cpix, 
					   cell[n].paint_gc[p][c], x,y);
			}
		    for (c=0;c<MAX_COLOR;c++)
			XFreeGC(disp,cell[n].paint_gc[p][c]);
		} else {		/* monochrome */
		    cell[n].gc_bw[0]=XCreateGC(disp,cpix,0,NULL);
		    cell[n].gc_bw[1]=XCreateGC(disp,cpix,0,NULL);
		    XSetForeground(disp,cell[n].gc_bw[0],w_pixel);
		    XSetForeground(disp,cell[n].gc_bw[1],b_pixel);
		    XFillRectangle(disp,cpix,cell[n].gc_bw[0],0,0,xs,ys);
		    cell[n].mono_buf=(unsigned char *)malloc(xs*ys);
		    monochrome(n,p);
		    b=cell[n].mono_buf;
		    for (y=0;y<ys;y++)
			for (x=0;x<xs;x++)
			    if ((*b++)==1)
				XDrawPoint(disp, cpix, cell[n].gc_bw[1], x,y);
		}
		cell[n].pix[p]=cpix;
	    }
	    if (quiet_mode==OFF) {
		fprintf(stderr,".");
		fflush(stderr);
	    }
	}
    }
}

void set_back_color(STATE flag)
{
    if (color_mode==ON)
 	XSetForeground(disp,world_gc,palet[pb[current_set]][0].pixel);
    else
	make_mono_background(flag);
}

void remake_world_pixmap(int sx,int sy)
{
    static STATE	init_status=OFF;

    if (init_status==ON) {
	XFreeGC(disp,world_gc);
	XFreePixmap(disp,world_pix);
	if (color_mode==OFF) {
	    XFreeGC(disp,mono_background_gc);
	    XFreePixmap(disp,mono_background_pix);
	}
    }
    init_status=ON;
    size_x=sx;
    size_y=sy;
    world_pix=XCreatePixmap(disp,w, size_x,size_y, XDefaultDepth(disp,0));
    world_gc=XCreateGC(disp,world_pix,0,NULL);
    if (color_mode==OFF) {
	mono_background_pix=XCreatePixmap(disp,w,size_x,size_y,
					  XDefaultDepth(disp,0));    
	mono_background_gc=XCreateGC(disp,mono_background_pix,0,NULL);
    }
    set_back_color(ON);
}

void put_all()
{
    int	i;

    if (color_mode==ON)
	XFillRectangle(disp,world_pix,world_gc, 0,0, size_x,size_y);
    else 
	XCopyArea(disp,mono_background_pix,world_pix,mono_background_gc,
		  0,0, size_x,size_y, 0,0);
    for (i=MAX_CELL-1;i>=0;i--) {
	int	x,y,p;
	if (cell[i].set[current_set]==NOUSE) continue;
	x=cell[i].x[current_set];
	y=cell[i].y[current_set];
	p=(palet_mode==ON)	? 0 : palet_array[pb[current_set]];
	XSetClipOrigin(disp,cell[i].gc[p],x,y);
	XCopyArea(disp,cell[i].pix[p],world_pix,cell[i].gc[p],
		  0,0, cell[i].xsize,cell[i].ysize, x,y);
    }    
    XCopyArea(disp,world_pix,w,world_gc, 0,0, size_x,size_y, 0,0);
}
void put_image(int pmark,int px,int py)
{
    int	left =size_x+1,right =-1,top =size_y+1,bottom =-1;
    int	left2=size_x+1,right2=-1,top2=size_y+1,bottom2=-1;
    int	sx,sy,ex,ey;
    int	i,p;

    for (i=MAX_CELL-1;i>=0;i--) {
	if (cell[i].set[current_set]==NOUSE) continue;
	if (cell[i].mark!=pmark) continue;
	sx=cell[i].x[current_set];
	sy=cell[i].y[current_set];
	ex=cell[i].xsize + sx;
	ey=cell[i].ysize + sy;
	if (sx<left2) 	left2=sx;
	if (right2<ex) 	right2=ex;
	if (sy<top2) 	top2=sy;
	if (bottom2<ey) 	bottom2=ey;
	ex=cell[i].xsize + px;
	ey=cell[i].ysize + py;
	if (px<left) 	left=px;
	if (right<ex) 	right=ex;
	if (py<top) 	top=py;
	if (bottom<ey) 	bottom=ey;
	cell[i].x[current_set]=px;
	cell[i].y[current_set]=py;
    }
    if (left2<left)		left=left2;
    if (top2<top)		top=top2;
    if (right<right2)	right=right2;
    if (bottom<bottom2)	bottom=bottom2;
	
    if (left<0) 		left=0;
    if (right>size_x)	right=size_x;
    if (top<0) 		top=0;
    if (bottom>size_y)	bottom=size_y;

    if (color_mode==ON)
	XFillRectangle(disp,world_pix,world_gc, 
		       left2,top2, right2-left2,bottom2-top2);
    else 
	XCopyArea(disp,mono_background_pix,world_pix,mono_background_gc,
		  left2,top2, right2-left2,bottom2-top2,left2,top2);

    for (i=MAX_CELL-1;i>=0;i--) {
	int		cw,ch,cox,coy;
	if (cell[i].set[current_set]==NOUSE) continue;
	sx=cell[i].x[current_set];
	sy=cell[i].y[current_set];
	ex=cell[i].xsize + sx;
	ey=cell[i].ysize + sy;
	if (right<=sx ||bottom<=sy || ex<=left || ey<=top) 	continue;
	cox= (sx<=left  ) ? left   : sx;
	cw = (ex<=right ) ? ex-cox : right-cox;
	coy= (sy<=top   ) ? top    : sy;
	ch = (ey<=bottom) ? ey-coy : bottom-coy;
	p=(palet_mode==ON) ? 0 : palet_array[pb[current_set]];
	XSetClipOrigin(disp,cell[i].gc[p], sx,sy);
	XCopyArea(disp,cell[i].pix[p],world_pix,cell[i].gc[p],
		  cox-sx,coy-sy, cw,ch, cox,coy);
    }
    XCopyArea(disp,world_pix,w,world_gc, 
	      left,top, right-left,bottom-top, left,top);
}

void put_button(enum GROUP group,int n,STATE state)
{
    COLOR 	color1,color2;
    int		x;
    char	*number[]={"0","1","2","3","4","5","6","7","8","9"};

    if (state==ON) {
	color1=BLACK;	color2=GREEN;
    } else {
	color1=GREEN;	color2=BLACK;
    }
    
    switch(group) {
    case SET:
    case PAL:
	x = ((group==SET) ? BTN_X_SET : BTN_X_PAL) + (BTN_WIDTH+BTN_SPACE)*n;
        
	XFillRectangle(disp,w,gc_button[color1],
		       x,size_y+BTN_SPACE,BTN_WIDTH,BTN_HEIGHT);
	XDrawRectangle(disp,w,gc_button[color2],
		       x,size_y+BTN_SPACE,BTN_WIDTH,BTN_HEIGHT);
	XDrawString(disp,w,gc_button[color2],
		    x+FONT_X,size_y+BTN_SPACE+FONT_Y,number[n],1);
	break;
    case QUIT:
        x = BTN_X_QUIT;
	XFillRectangle(disp,w,gc_button[color1],
		       x,size_y+BTN_SPACE,QUIT_WIDTH,BTN_HEIGHT);
	XDrawRectangle(disp,w,gc_button[color2],
		       x,size_y+BTN_SPACE,QUIT_WIDTH,BTN_HEIGHT);
	XDrawString(disp,w,gc_button[color2],
		    x+FONT_X,size_y+BTN_SPACE+FONT_Y,"Quit",4);
	break;
    }
}

void redisplay()
{
    int		i;
    
    XFillRectangle(disp,w,gc_button[ORANGE], 0,size_y, size_x,BTN_Y_OFFSET);

    for (i=0; i<MAX_SET; i++)
        put_button(SET, i, (current_set==i) ? ON : OFF);
    for (i=0; i<MAX_PAL; i++)
        put_button(PAL, i, (pb[current_set]==i) ? ON : OFF);
    put_button(QUIT, 0, quit_state);
    
    put_all();
}

void check_command(int x,int y)
{
    int		i;
    
    if (y < size_y) return;

    if (x < BTN_X_SET) return;
    for (i=0;i<MAX_SET;i++)
	if (x<BTN_X_SET + (BTN_WIDTH+BTN_SPACE)*(i+1)) {
	    current_set=i;
	    if (palet_mode==ON)
		repaint_pixmap(pb[current_set],OFF);
	    set_back_color(OFF);
	    redisplay();
	    return;
	}
    if (x < BTN_X_PAL) return;
    for (i=0;i<MAX_PAL;i++)
	if (x < BTN_X_PAL + (BTN_WIDTH+BTN_SPACE)*(i+1)) {
	    pb[current_set]=i;
	    if (palet_mode==ON)
		repaint_pixmap(pb[current_set],OFF);
	    set_back_color(OFF);
	    redisplay();
	    return;
	}

    if (x < BTN_X_QUIT)	return;    
    quit_state=ON;
    redisplay();
    quit();
}

void button_press(int mx,int my)
{
    int		i;
    
    press_mark = -1;
    if (my>=size_y) return;
    for (i=0;i<MAX_CELL;i++) {
	int x,y,sx,sy;
	if (cell[i].mark==-1) continue;
	if (cell[i].set[current_set]==NOUSE) continue;
	x=cell[i].x[current_set];
	y=cell[i].y[current_set];
	sx=cell[i].xsize;
	sy=cell[i].ysize;
	if (x<=mx && mx<x+sx && y<=my && my<y+sy)
	    if (cell[i].buf[(my-y)*sx+(mx-x)]!=0) {
		press_cell=i;
		press_mark=cell[i].mark;
		break;
	    }
    }
    if (press_mark == -1) 
	return; /* no cell pressed */

    press_dx = mx-cell[press_cell].x[current_set];
    press_dy = my-cell[press_cell].y[current_set];
    fix_press_x=mx-press_dx;
    fix_press_y=my-press_dy;
    pesi_flag=OFF;
}

void button_motion(int mx,int my)
{
    int		num,i;
    
    if (press_mark==-1)	return;
    
    if (fix[press_mark]>0) {
	int	x=mx-fix_press_x-press_dx;
	int	y=my-fix_press_y-press_dy;
	if (pesi_flag==ON) return;
	if (((x>0) ? x : -x)+((y>0) ? y : -y)>=(big_mode==ON) ? 6:3) {
	    int	f;
	    f=init_fix[press_mark];
	    if (f>64)	f=64;
	    f=(f-fix[press_mark])/4;
	    if (f<0) f=0;
	    if (big_mode==ON) f*=2;
	    if (y<0 || y>f || x>f || x<-f) {
		x=y=0;
		pesi_flag=ON;
	    }
	    mx = x + fix_press_x + press_dx;
	    my = y + fix_press_y + press_dy;
	    put_image(press_mark,fix_press_x + x , fix_press_y + y);
	    return;
	}
    } else {
	if (mx<0)	mx=0;
	if (size_x<mx) 	mx=size_x;
	if (my<0) 		my=0;
	if (size_y<my) 	my=size_y;
	
	put_image(press_mark,mx-press_dx,my-press_dy);
    }
}

void button_release(int mx,int my)
{
    if (press_mark==-1)	return;

    if (fix[press_mark]>0) {
	int	x=mx-fix_press_x-press_dx;
	int	y=my-fix_press_y-press_dy;
	int	i;
	if (((x>0) ? x : -x)+((y>0) ? y : -y)>(big_mode==ON) ? 6:3) {
	    int	i,f;
	    f=fix[press_mark];
	    fix[press_mark]=0;
	    i=5;
	    do {
		f>>=1;
		fix[press_mark]+=f;
	    } while (--i);
	}
	if (x!=0 || y!=0) 
	    put_image(press_mark,fix_press_x,fix_press_y);
    }
}

void xor_rectangle(int sx,int sy,int ex,int ey)
{
    int		x,y,dx,dy;

    x = (sx<ex) ? sx : ex;
    y = (sy<ey) ? sy : ey;
    dx = (sx<ex) ? ex-sx : sx-ex;
    dy = (sy<ey) ? ey-sy : sy-ey;
    XDrawRectangle(disp,w,root_box_gc, x,y, dx,dy);
}

void root_press(int mx,int my)
{
    root_sx=root_ex=mx;
    root_sy=root_ey=my;
    root_flag=OFF;
}

void root_motion(int mx,int my)
{
    if (root_flag==ON)
	xor_rectangle(root_sx,root_sy,root_ex,root_ey);
    root_flag=ON;
    if (mx<0) mx=0;
    if (my<0) my=0;
    if (mx>size_x)	mx=size_x;
    if (my>size_y)	my=size_y;
    root_ex=mx;
    root_ey=my;
    xor_rectangle(root_sx,root_sy,root_ex,root_ey);
}

void root_release()
{
    Pixmap	bpix;
    GC		gc;
    int		sx,sy,dx,dy;

    xor_rectangle(root_sx,root_sy,root_ex,root_ey);
    sx = (root_sx<root_ex) ? root_sx : root_ex;
    sy = (root_sy<root_ey) ? root_sy : root_ey;
    dx = (root_sx<root_ex) ? root_ex-root_sx : root_sx-root_ex;
    dy = (root_sy<root_ey) ? root_ey-root_sy : root_sy-root_ey;
    if (dx==0 || dy==0) return;
    bpix=XCreatePixmap(disp,w, dx,dy, XDefaultDepth(disp,0));    
    gc=XCreateGC(disp,w,0,NULL);
    XCopyArea(disp,world_pix,bpix,gc, sx,sy, dx,dy, 0,0);
    XSetWindowBackgroundPixmap(disp,rootwin,bpix);
    XFreeGC(disp,gc);
    XFreePixmap(disp,bpix);
    XClearWindow(disp,rootwin);
    root_paste_flag=ON;
}

void main(int argc,char **argv)
{
    XFontStruct	*font_info;
    int		pos_x=-9999,pos_y=-9999;    
    int		i;
    
    arg_check(argc,argv);

    if ((disp = XOpenDisplay(disp_name))==NULL) {
	fprintf(stderr,"error! can't open display(%s).\n",disp_name);
	exit(0);
    }

    load_config();

    rootwin = DefaultRootWindow(disp);
    scr = DefaultScreen(disp);
    if (reverse_mode==OFF) {
	w_pixel=WhitePixel(disp,scr);
	b_pixel=BlackPixel(disp,scr);
    } else {
	w_pixel=BlackPixel(disp,scr);
	b_pixel=WhitePixel(disp,scr);
    }

    if (geometry_string!=NULL) {
	int	x,y,flag_mask;
	char	geometry_default[40];
	unsigned int width,height;
	sprintf(geometry_default,"%dx%d",cnf_size_x,cnf_size_y+BTN_Y_OFFSET);
	flag_mask=XGeometry(disp,scr, geometry_string, geometry_default,
			    DEFAULT_BORDER_WIDTH, 1,1, 0,0,
			    &x,&y,&width,&height);
	if ((flag_mask & XValue) || (flag_mask & XNegative)) pos_x = x;
	if ((flag_mask & YValue) || (flag_mask & YNegative)) pos_y = y;
	if (flag_mask & WidthValue)  cnf_size_x = (int)width;
	if (flag_mask & HeightValue) cnf_size_y = (int)height;
	if ((flag_mask & YNegative) && (flag_mask & HeightValue))
	    cnf_size_y -= BTN_Y_OFFSET;
    }
    w=XCreateSimpleWindow(disp,rootwin, pos_x,pos_y, 
			  cnf_size_x,cnf_size_y+BTN_Y_OFFSET,
			  DEFAULT_BORDER_WIDTH,0,0);

    root_box_gc=XCreateGC(disp,w,0,NULL);
    XSetFunction(disp,root_box_gc,GXxor);
    if (color_mode==ON)
	XSetForeground(disp,root_box_gc,XDisplayCells(disp,scr)-1);
    else 
	XSetForeground(disp,root_box_gc,1);

    make_palet();
    init_cell_pixmap();
    remake_world_pixmap(cnf_size_x,cnf_size_y);

    {
	XSizeHints	hints;
	hints.min_width  = size_x;
	hints.min_height = size_y+BTN_Y_OFFSET;
	hints.flags=PMinSize;
	if (pos_x!=-9999) {
	    hints.x = pos_x;
	    hints.y = pos_y;
	    hints.flags |= USPosition;
	}
	XSetNormalHints(disp,w,&hints);
    }
    if (iconic_mode==ON) {
	XWMHints	wmhint;
	wmhint.initial_state=IconicState;
	wmhint.flags=StateHint;
	XSetWMHints(disp,w,&wmhint);
    }

    XStoreName(disp,w,"xkiss");
    XSetIconName(disp,w,"xkiss");
    {
	char	**cname;

	if (color_mode==ON) {
	    cname=color_name;
	} else {
	    if (reverse_mode==OFF) cname=mono_color_name;
	    else		   cname=mono_reverse_color_name;
	}
	font_info = XLoadQueryFont(disp,FONTNAME);
	for (i=0;i<SYS_COL;i++) {
	    XColor	col,exact;
	    XAllocNamedColor(disp,XDefaultColormap(disp,0),
			     cname[i],&exact,&col);
	    gc_button[i] = XCreateGC(disp,w,0,NULL);
	    XSetForeground(disp,gc_button[i],col.pixel);
	    XSetFont(disp,gc_button[i],font_info->fid);
	}
    }

    if (quiet_mode==OFF)
	fprintf(stderr, "\nLet's KISS !!\n");

    XSelectInput(disp,w,
		 ExposureMask | StructureNotifyMask | 
		 ButtonPressMask | ButtonMotionMask | ButtonReleaseMask);
    XMapWindow(disp,w);
    while(True) {
	XEvent	ev;
	static	int	button_status;

	XNextEvent(disp,&ev);
	switch(ev.type) {
	case Expose:
	    redisplay();
	    break;
	case ButtonPress:
	    switch (ev.xbutton.button) {
	    case Button2:
		root_press(ev.xbutton.x,ev.xbutton.y);
		break;
	    case Button3:
		/* if your X don't have XIconifyWindow(), deleate next line. */
		XIconifyWindow(disp,w,scr);
		break;
	    default:
		check_command(ev.xbutton.x,ev.xbutton.y);
		button_press(ev.xbutton.x,ev.xbutton.y);
		break;
	    }
	    button_status = ev.xbutton.button;
	    break;
	case MotionNotify:
	    switch (button_status) {
	    case Button2:
		root_motion(ev.xbutton.x,ev.xbutton.y);
		break;
	    default:
		button_motion(ev.xbutton.x,ev.xbutton.y);
		break;
	    }
	    break;
	case ButtonRelease:
	    switch (button_status) {
	    case Button1:
		button_release(ev.xbutton.x,ev.xbutton.y);
		break;
	    case Button2:
		root_release();
		break;
	    default:
		break;
	    }
	    break;
	case ConfigureNotify:
	    remake_world_pixmap(ev.xconfigure.width,
				ev.xconfigure.height-BTN_Y_OFFSET);
	    redisplay();
	    break;
	}
    }
}
